<script setup>
import { toast } from 'bulma-toast'

const router = useRouter()
const route = useRoute()
const activeSave = useActiveSave()

definePageMeta({
  middleware: ['auth', 'org']
})

const lastRecord = ref({})
const form = ref({
  id: '',
  uid: '',
  client: '',
  clientId: '',
  organization: '',
  organizationId: '',
  name: '',
  description: '',
  shippingServiceCode: '',
  trackingURL: '',
  isActive: true,
  isInternational: false,
  isOnline: false,
  isResidential: false,
  isSaturdayDelivery: false,
  shippingProcessorCfg: '',
  shippingProcessorCfgId: '',
  processing: false,
  alert: {
    status: '',
    message: '',
    processing: false
  }
})

const retrieve = async () => {
  const res = await $fetch('/api/materials/shipper-configurations/'+route.params.id, {
    headers: useRequestHeaders(['cookie'])
  })
  if(res) {
    form.value = {
      id: route.params.id,
      uid: res?.uid || '',
      client: res?.AD_Client_ID?.identifier || '',
      clientId: res?.AD_Client_ID?.id || '',
      organization: res?.AD_Org_ID?.identifier || '',
      organizationId: res?.AD_Org_ID?.id || '',
      name: res?.Name || '',
      description: res?.Description || '',
      shippingServiceCode: res?.ShippingServiceCode || '',
      trackingURL: res?.TrackingURL || '',
      isActive: res?.IsActive ?? true,
      isInternational: res?.IsInternational ?? false,
      isOnline: res?.IsOnline ?? false,
      isResidential: res?.IsResidential ?? false,
      isSaturdayDelivery: res?.IsSaturdayDelivery ?? false,
      shippingProcessorCfg: res?.M_ShippingProcessorCfg_ID?.identifier || '',
      shippingProcessorCfgId: res?.M_ShippingProcessorCfg_ID?.id || '',
      processing: false,
      alert: {
        status: '',
        message: '',
        processing: false
      }
    }
    lastRecord.value = res
    setNoEdit()
    activeSave.value = false
  }
}
onMounted(retrieve)

const noEdit = ref(true)
const setNoEdit = () => {
  noEdit.value = (
    form.value.organizationId == (lastRecord.value?.AD_Org_ID?.id || '') &&
    form.value.name == (lastRecord.value?.Name || '') &&
    form.value.description == (lastRecord.value?.Description || '') &&
    form.value.shippingServiceCode == (lastRecord.value?.ShippingServiceCode || '') &&
    form.value.trackingURL == (lastRecord.value?.TrackingURL || '') &&
    form.value.isActive == (lastRecord.value?.IsActive ?? true) &&
    form.value.isInternational == (lastRecord.value?.IsInternational ?? false) &&
    form.value.isOnline == (lastRecord.value?.IsOnline ?? false) &&
    form.value.isResidential == (lastRecord.value?.IsResidential ?? false) &&
    form.value.isSaturdayDelivery == (lastRecord.value?.IsSaturdayDelivery ?? false) &&
    form.value.shippingProcessorCfgId == (lastRecord.value?.M_ShippingProcessorCfg_ID?.id || '')
  ) ? true : false
}

const duplicate = () => {
  router.push(`/materials/shipper-configurations/${route.params.id}/duplicate`)
}

const back = () => {
  if(activeSave.value) {
    toast({
      message: 'Save button is active, please submit the data before leaving!',
      type: 'is-warning',
      duration: 2000
    })
  } else {
    router.push('/materials/shipper-configurations')
  }
}

const save = async (record) => {
  form.value = record
  setNoEdit()
  if(!noEdit.value) {
    activeSave.value = true
  } else {
    activeSave.value = false
  }
}

const submit = async (saveType = '') => {
  form.value.alert.processing = true
  activeSave.value = true

  const res = await $fetch('/api/materials/shipper-configurations/update', {
    method: 'PUT',
    headers: useRequestHeaders(['cookie']),
    body: {
      id: form.value.id,
      organizationId: form.value.organizationId,
      name: form.value.name,
      description: form.value.description,
      shippingServiceCode: form.value.shippingServiceCode,
      trackingURL: form.value.trackingURL,
      isActive: form.value.isActive,
      isInternational: form.value.isInternational,
      isOnline: form.value.isOnline,
      isResidential: form.value.isResidential,
      isSaturdayDelivery: form.value.isSaturdayDelivery,
      shippingProcessorCfgId: form.value.shippingProcessorCfgId,
    }
  })

  if(Number(res.status) === 200) {
    form.value.alert.processing = false
    activeSave.value = false
    if(saveType === 'preview') {
      router.push('/materials/shipper-configurations/'+res.id+'/view')
    } else if(saveType === 'changes') {
      location.reload()
    } else if(saveType === 'onlysave') {
      toast({
        message: 'Saved!',
        type: 'is-success',
        duration: 2000
      })
      retrieve()
    } else {
      back()
    }
  } else {
    //form.value.alert.status = res.status
    //form.value.alert.message = res.message
    form.value.alert.processing = false
    activeSave.value = false
    toast({
      message: res.message || 'Save error',
      type: 'is-danger',
      duration: 2000
    })
  }
}

const showAttachment = ref(false)

const breadCrumb = computed(() => ([
  { link: '#', text: 'Materials'},
  { link: '/materials/shipper-configurations', text: 'Shipper Configurations'},
  { link: '#', text: 'Edit Shipper Configuration', active: true}
]))
</script>

<template>
  <Head>
    <Title>Edit Shipper Configuration</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    
    <div class="bannercontrol">
      <div class="d-flex gap-10px">
        <button type="button" @click="submit('onlysave')" class="button" :class="(form.name === '' || noEdit || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save</button>
        <template v-if="form.id !== ''">
          <button type="button" @click="submit" class="button" :class="(form.name === '' || noEdit || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save + Exit</button>
          <button type="button" @click="showAttachment = true" class="button" :class="(form.name === '' || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Attachment</button>
          <button type="button" @click="duplicate" class="button" :class="(!noEdit || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Duplicate</button>
        </template>
      </div>
      <div>
        <div class="d-flex gap-10px">
          <button v-if="activeSave" type="button" @click="activeSave = false; back();" class="button">
            <span class="tf-icon ti ti-square-x ti-xs me-1 color-inherit"></span> Abort
          </button>
          <button type="button" @click="back" class="button">
            <span class="tf-icon ti ti-chevron-left ti-xs me-1 color-inherit"></span> Back
          </button>
        </div>
      </div>
    </div>

    <div class="banner">
      <div class="editwrapper">
        <MaterialsShipperConfigurationForm v-model="form" @save="save"/>
      </div>
      <div>
        <MaterialsShipperConfigurationDetailRecord action="edit" :info="form" />
      </div>
      <div>
        <AttachmentModal v-model="showAttachment" target="m_shippercfg" :info="form" />
      </div>
    </div>
  </NuxtLayout>
</template>